<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des organismes instructeurs n'ont pas pu être chargées."
    />
    <template v-else-if="organismesInstructeursCounts">
      <h2 class="fr-h5">Organismes instructeurs</h2>
      <p>
        Pourcentage calculé sur le nombre total de demandes instruites en
        externe
      </p>
      <StatsList
        v-if="organismesInstructeursCounts.length"
        :total-count="totalCount"
        :stats="organismesInstructeursCounts"
      />
      <p v-else>
        Commencez à créer des instructions de demande d'aides dans les fiches de
        bénéficiaires pour voir apparaître les statistiques de la répartition
        des organismes instructeurs.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { AlertType } from '~~/utils/constants/alert'
  import { HELP_REQUEST_COLOR } from '~~/utils/constants/help-requests'
  import { errorResponseMessage } from '~~/utils/errorResponse'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: organismesInstructeurs,
    pending,
    error
  } = useLazyAsyncData(
    `${props.collection}organismesInstructeurs`,
    loadOrganismesInstructeurs,
    {
      server: false
    }
  )

  const organismesInstructeursCounts = computed(() => {
    const organismesInstructeursCounts = organismesInstructeurs.value.reduce(
      (_organismesInstructeursCounts, historyItem) => {
        const organismeInstructeurId =
          historyItem.organisme_instructeur?.id || null
        if (organismeInstructeurId in _organismesInstructeursCounts) {
          _organismesInstructeursCounts[organismeInstructeurId].count++
        } else {
          _organismesInstructeursCounts[organismeInstructeurId] = {
            key: organismeInstructeurId,
            label: historyItem.organisme_instructeur?.name || 'Non renseigné',
            color: HELP_REQUEST_COLOR,
            count: 1
          }
        }
        return _organismesInstructeursCounts
      },
      {}
    )
    const organismesInstructeursCountsValues = Object.values(
      organismesInstructeursCounts
    )
    organismesInstructeursCountsValues.sort((a, b) => b.count - a.count)
    return organismesInstructeursCountsValues
  })

  const totalCount = computed(() => organismesInstructeurs.value.length)

  async function loadOrganismesInstructeurs() {
    const res = await $getItems('help_requests', {
      fields: ['organisme_instructeur.id', 'organisme_instructeur.name'],
      filter: {
        external_organisation: { _eq: true },
        ...props.filters
      }
    })

    if (res.status === 200) return res.data.data
    throw new Error(errorResponseMessage(res))
  }
</script>
